use std::thread::{Thread, JoinGuard};

pub trait Executor {
    type Guard;
    fn submit(&self, job: F) where F: FnOnce() -> Self::Guard;
}

pub struct NativeThreadPerJob;

impl Executor for NativeThreadPerJob {
    type Guard = JoinGuard
}
